function TinyWav(pid, trigger) {
    this.pid = pid;
    this.State = "STOPPED";
    this.initCnt = 0;
    this.player = undefined;
    this.playlist = [];
    this.trigger_buffer = trigger;
    this.doplaylist = false;
    this.icon;

    this.Play = function(file,icon) {
        var player = this.getPlayer();
        this.icon = icon;
        if (!file) {
            this.doplaylist = true;
            if (this.State != "STOPPED" || !this.playlist.length)
                return;
            file = this.playlist[0];
        } else 
        if (typeof file == "object") {
            this.playlist = file;
            this.doplaylist = true;
            if (this.State != "STOPPED" || !this.playlist.length)
                return;
            file = this.playlist[0];
        } else {
            this.doplaylist = false;
        }
        this.Stop();
        player.doPlay(file, this.trigger_buffer);
    }

    this.Enqueue = function(file) {
        if (typeof file == "object") {
            this.playlist = this.playlist.concat(file);
        }
        else if (file) {
            if (!this.playlist || !this.playlist.length)
                this.playlist = [file];
            else
                this.playlist[this.playlist.length] = file;
        }
    }
    this.Stop = function () {
        var player = this.getPlayer();
        player.doStop();
    }
    this.Pause = function (file,icon) {
        var player = this.getPlayer();
        this.icon = icon;
        player.doPause();
    }
    this.Resume = function () {
        var player = this.getPlayer();
        player.doResume();
    }
    this.Next = function() {
        var player = this.getPlayer();
        if(this.playlist.length) this.playlist.shift();
        if (!this.playlist.length)
            return;
        file = this.playlist[0];
        player.doStop();
        player.doPlay(file, this.trigger_buffer);
    }
    this.getPlayer = function() {
        if(this.player!=undefined) return this.player;
        var obj = document.getElementById(this.pid);
        if (!obj) return null;
        if (obj.doPlay) {
            this.player = obj;
            return obj;
        }
        for(i=0; i<obj.childNodes.length; i++) {
            var child = obj.childNodes[i];
            if (child.tagName == "EMBED") {
                this.player = child;
                return child;
            }
        }
    }

    this.SoundState = function (state, position) {
        if (position != undefined) this.SoundPos = position;
        if (this.State == "PLAYING" && state=="STOPPED" && this.doplaylist) {
            window.setTimeout((function(t){ 
                return function(){ t.Next(); };
            })(this), 50);
        }
        this.State = state;
        debug(this.icon);
        if(state == "PLAYING") {
            $('#'+this.icon).removeClass('glyphicon-play');
            $('#'+this.icon).addClass('glyphicon-pause');
        } else if(state=="STOPPED") {
            $('#'+this.icon).addClass('glyphicon-play');
            $('#'+this.icon).removeClass('glyphicon-pause');
        } else if(state=="PAUSED") {
            $('#'+this.icon).addClass('glyphicon-play');
            $('#'+this.icon).removeClass('glyphicon-pause');
        }
    }
    this.init = function () {
        var player = this.getPlayer();
        this.initCnt++;
        if (!player || !player.attachHandler) {
            if (this.initCnt < 50)
                setTimeout((function(t){ return function(){ return t.init(); } })(this), 100); 
        } else {
            player.attachHandler("PLAYER_BUFFERING", "TinyWavSoundState", "BUFFERING");
            player.attachHandler("PLAYER_PLAYING", "TinyWavSoundState", "PLAYING");
            player.attachHandler("PLAYER_STOPPED", "TinyWavSoundState", "STOPPED");
            player.attachHandler("PLAYER_PAUSED", "TinyWavSoundState", "PAUSED");
        }
    }
}

function TinyWavSoundState() { window.TinyWav.SoundState.apply(window.TinyWav, arguments); }

window.TinyWav = new TinyWav('TinyWavBlock', 2);

function List_move_around(direction, all) {

    if (direction=="right") {
            box1 = "List_Extensions_available";
            box2 = "List_Extensions[]";
    } else {
            box1 = "List_Extensions[]";
            box2 = "List_Extensions_available" + "";
    }

    for (var i=0;i<document.forms[0].elements[box1].length;i++) {
          if ((document.forms[0].elements[box1][i].selected || all)) {
            document.forms[0].elements[box2].options[document.forms[0].elements[box2].length] =    new Option(document.forms[0].elements[box1].options[i].text, document.forms[0].elements[box1][i].value);
            document.forms[0].elements[box1][i] = null;
            i--;
        }
    }
    return false;
}

function List_check_submit() {
   box = "List_Extensions[]";
   if (document.forms[0].elements[box]) {
     for (var i=0;i<document.forms[0].elements[box].length;i++) {
        document.forms[0].elements[box][i].selected = true;
     }
   }
  return true;
}

function envia() {

    List_check_submit();

     box = "List_Extensions[]";
       if (document.forms[0].elements[box].length == 0) {
        alert("Please select at least one Extension");
        return false;
    }

    month_start = parseInt(document.forms[0].month1.value) + 1;
    month_end   = parseInt(document.forms[0].month2.value) + 1;

    fecha_s  = document.forms[0].year1.value  + '-';
    if(String(month_start).length == 1) {
        fecha_s += "0";
    } 
    fecha_s += month_start + '-';
    if(String(document.forms[0].day1.value).length == 1) {
        fecha_s += "0";
    }
    fecha_s += document.forms[0].day1.value   + ' ';
    fecha_s += '00:00:00';

    fecha_check_s = document.forms[0].year1.value;
    if(String(month_start).length == 1) {
        fecha_check_s += "0";
    } 
    fecha_check_s += month_start;
    if(String(document.forms[0].day1.value).length == 1) {
        fecha_check_s += "0";
    }
    fecha_check_s += document.forms[0].day1.value;

    fecha_check_e = document.forms[0].year2.value;
    if(String(month_end).length == 1) {
        fecha_check_e += "0";
    } 
    fecha_check_e += month_end;
    if(String(document.forms[0].day2.value).length == 1) {
        fecha_check_e += "0";
    }
    fecha_check_e += document.forms[0].day2.value;

    fecha_e  = document.forms[0].year2.value  + '-';
    if(String(month_end).length == 1) {
        fecha_e += "0";
    } 
    fecha_e += month_end + '-';
    if(String(document.forms[0].day2.value).length == 1) {
        fecha_e += "0";
    }
    fecha_e += document.forms[0].day2.value   + ' ';
    fecha_e += '23:59:59';

    document.forms[0].start.value = fecha_s;
    document.forms[0].end.value   = fecha_e;

    if(fecha_check_e < fecha_check_s) {
        alert("<?=$lang[$language]['invaliddate']?>");
    } else { 
      document.forms[0].submit();
    }
    return false;
}

function setdates(start,end) {
    var start_year  = start.substr(0,4);
    var start_month = start.substr(5,2);
    var start_day   = start.substr(8,2);

    var end_year  = end.substr(0,4);
    var end_month = end.substr(5,2);
    var end_day   = end.substr(8,2);

    dstart = MWJ_findSelect( "day1" ), mstart = MWJ_findSelect( "month1" ), ystart = MWJ_findSelect( "year1" );
    dend   = MWJ_findSelect( "day2" ), mend   = MWJ_findSelect( "month2" ), yend   = MWJ_findSelect( "year2" );

    while( dstart.options.length ) { dstart.options[0] = null; }
    while( dend.options.length   ) { dend.options[0]   = null; }

    for( var x = 0; x < 31; x++  ) { dstart.options[x] = new Option( x + 1, x + 1 ); }
    for( var x = 0; x < 31; x++  ) { dend.options[x]   = new Option( x + 1, x + 1 ); }

    x = start_day - 1;
    y = end_day - 1;
    dstart.options[x].selected = true;
    dend.options[y].selected = true;
    
    x = start_month - 1;
    y = end_month - 1;
    mstart.options[x].selected = true;
    mend.options[y].selected   = true;

    for( var x = 0; x < ystart.options.length; x++ ) { 
        if( ystart.options[x].value == '' + start_year + '' ) { 
            ystart.options[x].selected = true; 
            if( window.opera && document.importNode ) { 
                window.setTimeout('MWJ_findSelect( \''+ystart.name+'\' ).options['+x+'].selected = true;',0); 
            } 
        } 
    }
    for( var x = 0; x < yend.options.length; x++ ) { 
        if( yend.options[x].value == '' + end_year + '' ) { 
            yend.options[x].selected = true; 
            if( window.opera && document.importNode ) { 
                window.setTimeout('MWJ_findSelect( \''+yend.name+'\' ).options['+x+'].selected = true;',0); 
            } 
        } 
    }
    $(".chosen-select").trigger("chosen:updated");
}

function changeDistMode(el) {
    if(el.options.selectedIndex==0) {
        $('.mincalls').show();
        $('.numcalls').hide();
    } else {
        $('.mincalls').hide();
        $('.numcalls').show();
    }
}

$(document).ready(function() {
    $('.chosen-select').chosen({disable_search: true, skip_no_results: true});
    $('.ttip').popover();
    $('.xtooltip').tooltip();

    var Player = document.createElement("div");
    Player.style.display = "block";
    Player.setAttribute("id", "TinyWavBlock");
    document.body.appendChild(Player);
    var vars = { }; var params = {'scale': 'noscale', 'bgcolor': '#FFFFFF'};
    swfobject.embedSWF("wavplayer.swf?gui=none", "TinyWavBlock", "1", "1", "10.0.32.18", "embed/expressInstall.swf", vars, params, params, go);

    wavesurfer = WaveSurfer.create({
        container: '#waveform',
        waveColor: 'violet',
        progressColor: 'purple'
    });

    var formatTime = function(time) {
        return [
        Math.floor((time % 3600) / 60), // minutes
        ('00' + Math.floor(time % 60)).slice(-2) // seconds
        ].join(':');
    };

    // Show current time
    wavesurfer.on('audioprocess', function() {
        if ($('#waveform_counter').length > 0) {
            $('#waveform_counter').text(formatTime(wavesurfer.getCurrentTime()));
        }
    });

    // Show clip duration
    wavesurfer.on('ready', function() {
        if ($('#waveform_duration').length > 0) {
            $('#waveform_duration').text(formatTime(wavesurfer.getDuration()));
        }
    });


    var slider = document.querySelector('#slider');

    slider.oninput = function() {
        var zoomLevel = Number(slider.value);
        wavesurfer.zoom(zoomLevel);
    };


});

function go() {
   window.TinyWav.init();
}

function setLang(lang) {
    document.cookie='lang='+lang;
    window.location.reload();
}

function ajupdate(pagina,objeto,parametros) {
    debug("ajupdate pagina "+pagina+ " objeto "+objeto);
    elem = $('#det'+objeto);
    load = $('#loading'+objeto);
    if(!elem.is(':visible')) {
        load.css('visibility','visible');
        var url = pagina;
        var pars = parametros;
        $('#content'+objeto).load(pagina,parametros,function() { $('#loading'+objeto).css('visibility','hidden'); $('#det'+objeto).show(); });
    } else {
        elem.hide();
        load.css('visibility','hidden');
    }
    return false;
}

function debug(message) {
    if(window.console !== undefined) {
        console.log(message);
    }
}

function playSound(file,iconid) {
    debug($('#'+iconid));
    if($('#'+iconid).hasClass('glyphicon-play')) {
        debug("play "+file);
        window.TinyWav.Play("download.php?file="+file,iconid);
    } else {
        debug("pause "+file);
        window.TinyWav.Pause("download.php?file="+file,iconid);
    }
}

function downloadSound(url,pars) {
    debug($("#dloadform"));
    $('#dloadform').attr('action',url);
    $('#downloadfile').val(pars); 
    $('#dloadform').submit();
    return false;
}

function pagupdate(urlin,objeto,pagina,parametros) {
    debug(objeto);
    var pars = "report="+objeto+"&type=HTML&pagina="+pagina;
    if(parametros!='undefined') {
         pars+="&"+parametros;
    }
    $('#'+objeto).fadeTo('fast',0.01, function() {
        $.post( urlin, pars,
        function( data ) {
            debug($('#'+objeto));

            $('#'+objeto).empty().append( data ).fadeTo('fast',1);
        });
    });
    return false;
}

function wavplay(file, id, status) {
    $('#bplay').prop('disabled', true);
    $('#bpause').prop('disabled', true);
    wavesurfer.load(file);
    if($('#audiofile').length>0) {
        $('#audiofile').attr('href', file);
    }
    $('#wavplayer').modal();

    wavesurfer.on('ready', function() {
        $('#bplay').prop('disabled', false);
        $('#bpause').prop('disabled', false);
        wavesurfer.play();
    });
}

